ExtraWeightsEvent = {};
ExtraWeightsEvent_mt = Class(ExtraWeightsEvent, Event);
InitEventClass(ExtraWeightsEvent, "ExtraWeightsEvent");

function ExtraWeightsEvent:emptyNew()
    local self = Event:new(ExtraWeightsEvent_mt);
    self.className = "ExtraWeightsEvent";
    return self;
end;

function ExtraWeightsEvent:new(vehicle, weightIndex)
    local self = ExtraWeightsEvent:emptyNew();
	self.vehicle = vehicle;
	self.weightIndex = weightIndex;
    return self;
end;

function ExtraWeightsEvent:writeStream(streamId, connection)
	streamWriteInt32(streamId, networkGetObjectId(self.vehicle));
	streamWriteInt8(streamId, self.weightIndex);
end;

function ExtraWeightsEvent:readStream(streamId, connection)
	self.vehicle = networkGetObject(streamReadInt32(streamId));
	self.weightIndex = streamReadInt8(streamId);
	self:run(connection);
end;

function ExtraWeightsEvent:run(connection)
	self.vehicle:setExtraWeights(self.weightIndex, true);
	if not connection:getIsServer() then
		g_server:broadcastEvent(ExtraWeightsEvent:new(self.vehicle, self.weightIndex), nil, connection, self.vehicle);
	end;
end;

function ExtraWeightsEvent.sendEvent(vehicle, weightIndex, noEventSend)
	if not noEventSend then
		if g_server ~= nil then
			g_server:broadcastEvent(ExtraWeightsEvent:new(vehicle, weightIndex), nil, nil, vehicle);
		else
			g_client:getServerConnection():sendEvent(ExtraWeightsEvent:new(vehicle, weightIndex));
		end;
	end;
end;